Index: /trunk/anuga_core/documentation/user_manual/demos/channel1.py
===================================================================
--- /trunk/anuga_core/documentation/user_manual/demos/channel1.py	(revision 7769)
+++ /trunk/anuga_core/documentation/user_manual/demos/channel1.py	(revision 7770)
@@ -7,8 +7,11 @@
 # Import necessary modules
 #------------------------------------------------------------------------------
+
+# Import standard shallow water domain and standard boundaries.
+import anuga
+
+# Import rectangular cross mesh generator
 from anuga.abstract_2d_finite_volumes.mesh_factory import rectangular_cross
-from anuga.shallow_water import Domain
-from anuga.shallow_water import Reflective_boundary
-from anuga.shallow_water import Dirichlet_boundary
+
 
 #------------------------------------------------------------------------------
@@ -18,5 +21,5 @@
                                                len1=10.0, len2=5.0) # Mesh
 
-domain = Domain(points, vertices, boundary)  # Create domain
+domain = anuga.Domain(points, vertices, boundary)  # Create domain
 domain.set_name('channel1')                  # Output name
 
@@ -35,6 +38,6 @@
 # Setup boundary conditions
 #------------------------------------------------------------------------------
-Bi = Dirichlet_boundary([0.4, 0, 0])         # Inflow
-Br = Reflective_boundary(domain)             # Solid reflective wall
+Bi = anuga.Dirichlet_boundary([0.4, 0, 0])         # Inflow
+Br = anuga.Reflective_boundary(domain)             # Solid reflective wall
 
 domain.set_boundary({'left': Bi, 'right': Br, 'top': Br, 'bottom': Br})
Index: /trunk/anuga_core/source/anuga/file/sww.py
===================================================================
--- /trunk/anuga_core/source/anuga/file/sww.py	(revision 7769)
+++ /trunk/anuga_core/source/anuga/file/sww.py	(revision 7770)
@@ -1196,4 +1196,92 @@
 
 ##
+# @brief Get mesh and quantity data from an SWW file.
+# @param filename Path to data file to read.
+# @param quantities UNUSED!
+# @param verbose True if this function is to be verbose.
+# @return (mesh, quantities, time) where mesh is the mesh data, quantities is
+#         a dictionary of {name: value}, and time is the time vector.
+# @note Quantities extracted: 'elevation', 'stage', 'xmomentum' and 'ymomentum'
+def get_mesh_and_quantities_from_file(filename,
+                                      quantities=None,
+                                      verbose=False):
+    """Get and rebuild mesh structure and associated quantities from sww file
+
+    Input:
+        filename - Name os sww file
+        quantities - Names of quantities to load
+
+    Output:
+        mesh - instance of class Interpolate
+               (including mesh and interpolation functionality)
+        quantities - arrays with quantity values at each mesh node
+        time - vector of stored timesteps
+
+    This function is used by e.g.:
+        get_interpolated_quantities_at_polyline_midpoints
+    """
+
+    # FIXME (Ole): Maybe refactor filefunction using this more fundamental code.
+
+    import types
+    from Scientific.IO.NetCDF import NetCDFFile
+    from shallow_water import Domain
+    from anuga.abstract_2d_finite_volumes.neighbour_mesh import Mesh
+
+    if verbose: log.critical('Reading from %s' % filename)
+
+    fid = NetCDFFile(filename, netcdf_mode_r)    # Open existing file for read
+    time = fid.variables['time'][:]    # Time vector
+    time += fid.starttime[0]
+
+    # Get the variables as numeric arrays
+    x = fid.variables['x'][:]                   # x-coordinates of nodes
+    y = fid.variables['y'][:]                   # y-coordinates of nodes
+    elevation = fid.variables['elevation'][:]   # Elevation
+    stage = fid.variables['stage'][:]           # Water level
+    xmomentum = fid.variables['xmomentum'][:]   # Momentum in the x-direction
+    ymomentum = fid.variables['ymomentum'][:]   # Momentum in the y-direction
+
+    # Mesh (nodes (Mx2), triangles (Nx3))
+    nodes = num.concatenate((x[:,num.newaxis], y[:,num.newaxis]), axis=1)
+    triangles = fid.variables['volumes'][:]
+
+    # Get geo_reference
+    try:
+        geo_reference = Geo_reference(NetCDFObject=fid)
+    except: #AttributeError, e:
+        # Sww files don't have to have a geo_ref
+        geo_reference = None
+
+    if verbose: log.critical('    building mesh from sww file %s' % filename)
+
+    boundary = None
+
+    #FIXME (Peter Row): Should this be in mesh?
+    if fid.smoothing != 'Yes':
+        nodes = nodes.tolist()
+        triangles = triangles.tolist()
+        nodes, triangles, boundary = weed(nodes, triangles, boundary)
+
+    try:
+        mesh = Mesh(nodes, triangles, boundary, geo_reference=geo_reference)
+    except AssertionError, e:
+        fid.close()
+        msg = 'Domain could not be created: %s. "' % e
+        raise DataDomainError, msg
+
+    quantities = {}
+    quantities['elevation'] = elevation
+    quantities['stage'] = stage
+    quantities['xmomentum'] = xmomentum
+    quantities['ymomentum'] = ymomentum
+
+    fid.close()
+
+    return mesh, quantities, time
+
+
+
+##
 # @brief 
 # @parm time 
@@ -1251,6 +1339,4 @@
 
 
-
-
 ##
 # @brief 
@@ -1310,2 +1396,5 @@
 
     return coordinates, volumes, boundary
+
+
+
Index: /trunk/anuga_core/source/anuga/file/test_sww.py
===================================================================
--- /trunk/anuga_core/source/anuga/file/test_sww.py	(revision 7769)
+++ /trunk/anuga_core/source/anuga/file/test_sww.py	(revision 7770)
@@ -8,5 +8,5 @@
 from anuga.abstract_2d_finite_volumes.mesh_factory import rectangular
 from anuga.shallow_water.shallow_water_domain import Domain
-from sww import load_sww_as_domain
+from sww import load_sww_as_domain, weed, get_mesh_and_quantities_from_file
 
 # boundary functions
@@ -158,4 +158,97 @@
 
 
+    def test_get_mesh_and_quantities_from_sww_file(self):
+        """test_get_mesh_and_quantities_from_sww_file(self):
+        """     
+        
+        # Generate a test sww file with non trivial georeference
+        
+        import time, os
+        from Scientific.IO.NetCDF import NetCDFFile
+
+        # Setup
+        from mesh_factory import rectangular
+
+        # Create basic mesh (100m x 5m)
+        width = 5
+        length = 50
+        t_end = 10
+        points, vertices, boundary = rectangular(length, width, 50, 5)
+
+        # Create shallow water domain
+        domain = Domain(points, vertices, boundary,
+                        geo_reference = Geo_reference(56,308500,6189000))
+
+        domain.set_name('flowtest')
+        swwfile = domain.get_name() + '.sww'
+        domain.set_datadir('.')
+
+        Br = Reflective_boundary(domain)    # Side walls
+        Bd = Dirichlet_boundary([1, 0, 0])  # inflow
+
+        domain.set_boundary( {'left': Bd, 'right': Bd, 'top': Br, 'bottom': Br})
+
+        for t in domain.evolve(yieldstep=1, finaltime = t_end):
+            pass
+
+        
+        # Read it
+
+        # Get mesh and quantities from sww file
+        X = get_mesh_and_quantities_from_file(swwfile,
+                                              quantities=['elevation',
+                                                          'stage',
+                                                          'xmomentum',
+                                                          'ymomentum'], 
+                                              verbose=False)
+        mesh, quantities, time = X
+        
+
+        # Check that mesh has been recovered
+        assert num.alltrue(mesh.triangles == domain.get_triangles())
+        assert num.allclose(mesh.nodes, domain.get_nodes())
+
+        # Check that time has been recovered
+        assert num.allclose(time, range(t_end+1))
+
+        # Check that quantities have been recovered
+        # (sww files use single precision)
+        z=domain.get_quantity('elevation').get_values(location='unique vertices')
+        assert num.allclose(quantities['elevation'], z)
+
+        for q in ['stage', 'xmomentum', 'ymomentum']:
+            # Get quantity at last timestep
+            q_ref=domain.get_quantity(q).get_values(location='unique vertices')
+
+            #print q,quantities[q]
+            q_sww=quantities[q][-1,:]
+
+            msg = 'Quantity %s failed to be recovered' %q
+            assert num.allclose(q_ref, q_sww, atol=1.0e-6), msg
+            
+        # Cleanup
+        os.remove(swwfile)
+        
+        
+
+    def test_weed(self):
+        coordinates1 = [[0.,0.],[1.,0.],[1.,1.],[1.,0.],[2.,0.],[1.,1.]]
+        volumes1 = [[0,1,2],[3,4,5]]
+        boundary1= {(0,1): 'external',(1,2): 'not external',(2,0): 'external',(3,4): 'external',(4,5): 'external',(5,3): 'not external'}
+        coordinates2,volumes2,boundary2=weed(coordinates1,volumes1,boundary1)
+
+        points2 = {(0.,0.):None,(1.,0.):None,(1.,1.):None,(2.,0.):None}
+
+        assert len(points2)==len(coordinates2)
+        for i in range(len(coordinates2)):
+            coordinate = tuple(coordinates2[i])
+            assert points2.has_key(coordinate)
+            points2[coordinate]=i
+
+        for triangle in volumes1:
+            for coordinate in triangle:
+                assert coordinates2[points2[tuple(coordinates1[coordinate])]][0]==coordinates1[coordinate][0]
+                assert coordinates2[points2[tuple(coordinates1[coordinate])]][1]==coordinates1[coordinate][1]
+
 #################################################################################
 
Index: /trunk/anuga_core/source/anuga/file_conversion/file_conversion.py
===================================================================
--- /trunk/anuga_core/source/anuga/file_conversion/file_conversion.py	(revision 7769)
+++ /trunk/anuga_core/source/anuga/file_conversion/file_conversion.py	(revision 7770)
@@ -488,2 +488,44 @@
 
 
+##
+# @brief 
+# @param filename 
+# @param x 
+# @param y 
+# @param z 
+def write_obj(filename, x, y, z):
+    """Store x,y,z vectors into filename (obj format).
+
+       Vectors are assumed to have dimension (M,3) where
+       M corresponds to the number elements.
+       triangles are assumed to be disconnected
+
+       The three numbers in each vector correspond to three vertices,
+
+       e.g. the x coordinate of vertex 1 of element i is in x[i,1]
+    """
+
+    import os.path
+
+    root, ext = os.path.splitext(filename)
+    if ext == '.obj':
+        FN = filename
+    else:
+        FN = filename + '.obj'
+
+    outfile = open(FN, 'wb')
+    outfile.write("# Triangulation as an obj file\n")
+
+    M, N = x.shape
+    assert N == 3  #Assuming three vertices per element
+
+    for i in range(M):
+        for j in range(N):
+            outfile.write("v %f %f %f\n" % (x[i,j], y[i,j], z[i,j]))
+
+    for i in range(M):
+        base = i * N
+        outfile.write("f %d %d %d\n" % (base+1, base+2, base+3))
+
+    outfile.close()
+
Index: /trunk/anuga_core/source/anuga/file_conversion/test_file_conversion.py
===================================================================
--- /trunk/anuga_core/source/anuga/file_conversion/test_file_conversion.py	(revision 7769)
+++ /trunk/anuga_core/source/anuga/file_conversion/test_file_conversion.py	(revision 7770)
@@ -8,9 +8,12 @@
 from anuga.abstract_2d_finite_volumes.mesh_factory import rectangular
 from anuga.shallow_water.sww_file import SWW_file
-from data_manager import extent_sww
+from anuga.file.sww import extent_sww
 from anuga.config import netcdf_float, epsilon, g
 from Scientific.IO.NetCDF import NetCDFFile
 from anuga.file_conversion.file_conversion import tsh2sww, \
                         pmesh_to_domain_instance
+
+from anuga.file.mux import WAVEHEIGHT_MUX_LABEL, EAST_VELOCITY_LABEL, \
+                            NORTH_VELOCITY_LABEL
 
 import sys
@@ -1570,5 +1573,5 @@
         #print "sww_file",sww_file
         #dem_file = tempfile.mktemp(".dem")
-        domain = sww2domain(sww_file) ###, dem_file)
+        domain = load_sww_as_domain(sww_file) ###, dem_file)
         domain.check_integrity()
 
